AppTitle "Graph"

Dim grb#(360)
Dim lft#(360)
Dim exc#(360)

Dim s#(800)
Dim v#(800)
Dim a#(800)
Dim f#(800)

Global s0#
Global v0#
Global a0#
Global f0#
Global mx%
Global mx2%
Global fmax#
Global smax#
Global vmax#
Global amax#
Global fmin#
Global smin#
Global vmin#
Global amin#
Global yc%=350
Global win%=CreateWindow("Plot",GraphicsWidth()*0.5-400,GraphicsHeight()*0.5-300,800,600,Desktop(),1+4+8+32):RestoreWindow(win%)
Global can%=CreateCanvas(0,0,800,600,win%):SetBuffer CanvasBuffer(can%):ClsColor 255,255,255:Cls
Global menu1000%=CreateMenu("Data",1000,WindowMenu(win%))
Global menu1100%=CreateMenu("Export",1100,menu1000%)
Global menu1200%=CreateMenu("Exit",1200,menu1000%)
Global menu2000%=CreateMenu("Draw",2000,WindowMenu(win%))
Global menu2100%=CreateMenu("Fast",2100,menu2000%)
Global menu2200%=CreateMenu("Slow",2200,menu2000%)
Global menu3000%=CreateMenu("View",3000,WindowMenu(win%))
Global menu3100%=CreateMenu("Excenter",3100,menu3000%)
Global menu3200%=CreateMenu("s Hub",3200,menu3000%)
Global menu3300%=CreateMenu("s Teller",3300,menu3000%)
Global menu3400%=CreateMenu("v Hub",3400,menu3000%)
Global menu3500%=CreateMenu("a Hub",3500,menu3000%)
Global menu3600%=CreateMenu("F Hub",3600,menu3000%)
CheckMenu menu2200%
UpdateWindowMenu win%

Local iconwin%=GetWinOSHandle(win%)
SetWindowIcon(iconwin%,"Graph.ico")

GetCurve("Hub")
For i%=1 To 360
	lft#(i%)=grb#(i%)
Next
GetCurve("Excenter")
For i%=1 To 360
	exc#(i%)=grb#(i%)
Next

Draw(1)

Repeat
	Select WaitEvent()
		Case $201
			mx%=MouseX(can%)
			If MenuChecked(menu2200%)=True Then Cls:Draw(1)
		Case $202
			mx2%=MouseX(can%)
		Case $203
			If MenuChecked(menu2100%)=True Then SpotValue()
		Case $803
			Exit
		Case $1001
			Select EventData()
				Case 1200
					Exit
				Case 1100
					WriteCurve(RequestFile("Pfad fr Exportdatei:","txt",1,"output"))
				Case 2100
					CheckMenu menu2100%
					UncheckMenu menu2200%
					UpdateWindowMenu win%
					Cls
					mx%=0
					mx2%=0
					Draw(0)
				Case 2200
					CheckMenu menu2200%
					UncheckMenu menu2100%
					UpdateWindowMenu win%
					Cls
					Draw(1)
				Case 3100
					If MenuChecked(menu3100%)=1 Then UncheckMenu(menu3100%) Else CheckMenu(menu3100%)
					UpdateWindowMenu win%
				Case 3200
					If MenuChecked(menu3200%)=1 Then UncheckMenu(menu3200%) Else CheckMenu(menu3200%)
					UpdateWindowMenu win%
				Case 3300
					If MenuChecked(menu3300%)=1 Then UncheckMenu(menu3300%) Else CheckMenu(menu3300%)
					UpdateWindowMenu win%
				Case 3400
					If MenuChecked(menu3400%)=1 Then UncheckMenu(menu3400%) Else CheckMenu(menu3400%)
					UpdateWindowMenu win%
				Case 3500
					If MenuChecked(menu3500%)=1 Then UncheckMenu(menu3500%) Else CheckMenu(menu3500%)
					UpdateWindowMenu win%
				Case 3600
					If MenuChecked(menu3600%)=1 Then UncheckMenu(menu3600%) Else CheckMenu(menu3600%)
					UpdateWindowMenu win%
			End Select
	End Select
Forever
End

;FUNCTIONS-----------------------------------------------------------------------------------------------------------------------------------------------

Function Grid(t%)
	Color 230,230,230
	For x#=0 To 800 Step 90
		Line x#,0,x#,600
		If t%=1 Then 
			Color 140,140,140
			Text x#+5,yc%-15,Int(x#)
			Color 230,230,230
		End If
	Next
	
	For y#=-300 To 300 Step 50
		Line 0,y#+300,800,y#+300
		If t%=1 Then 
			Color 140,140,140
			Text 5,yc%-y#+3,Int(y#)
			Color 230,230,230
		End If
	Next

	Color 0,0,0
	Rect 0,yc%,800,2
End Function

Function DrwSpd(x#,r%,g%,b%)
	v#(x#)=((((s#(x#)-s0#)/1000)*2)/(0.3/360))
	s0#=s#(x#)
	If v#(x#)>vmax# And x#>1 Then vmax#=v#(x#)
	If v#(x#)<vmin# And x#>1 Then vmin#=v#(x#)
	Color r%,g%,b%
	If MenuChecked(menu3400%)=1 Then Line x#,yc%+100/0.6*-(v#(x#)),x#-1,yc%+100/0.6*-v0#:Rect x#,yc%+100/0.6*-(v#(x#)),3,3	
End Function

Function DrwAcc(x#,r%,g%,b%)
	a#(x#)=(v#(x#)-v0#)/(0.3/360)
	v0#=v#(x#)
	If a#(x#)>amax# And x#>1 Then amax#=a#(x#)
	If a#(x#)<amin# And x#>1 Then amin#=a#(x#)
	Color r%,g%,b%
	If MenuChecked(menu3500%)=1 Then Line x#,yc%+100/15.7*-(a#(x#)),x#-1,yc%+100/15.7*-a0#:Rect x#,yc%+100/15.7*-(a#(x#)),3,3
End Function

Function DrwForce(x#,r%,g%,b%)
	If s#(x#)<15 Then f#(x#)=(a#(x#)*2.5)+(2.5*9.81) Else f#(x#)=(2.5*9.81)
	a0#=a#(x#)
	If f#(x#)>fmax# And x#>1 Then fmax#=f#(x#)
	If f#(x#)<fmin# And x#>1 Then fmin#=f#(x#)
	Color r%,g%,b%
	If MenuChecked(menu3600%)=1 Then Line x#,yc%+100/40*-(f#(x#)),x#-1,yc%+100/40*-f0#:Rect x#,yc%+100/40*-(f#(x#)),3,3	
End Function

Function Draw(mode%)
	Grid(1)
	i%=0
	s0#=lft#(360)
	For x#=1 To 800 Step 1
		If x#=Int(x#) Then
			i%=i%+1:If i%>360 Then i%=1
		End If
		
		y#=exc#(i%)
		Color 160,200,0
		If MenuChecked(menu3100%)=1 Then Rect x#,yc%+150/1*-(y#),3,3

		If lft#(i%)<15 Then y#=lft#(i%) Else y#=15
		If y#>tmax# And x#>1 Then tmax#=y#
		If y#<tmin# And x#>1 Then tmin#=y#
		Color 200,0,0
		If MenuChecked(menu3300%)=1 Then Rect x#,yc%+200/20*-(y#),3,3
		
		s#(x#)=lft#(i%)
		If s#(x#)>smax# And x#>1 Then smax#=s#(x#)
		If s#(x#)<smin# And x#>1 Then smin#=s#(x#)
		Color 50,230,200
		If MenuChecked(menu3200%)=1 Then Line x#,yc%+200/20*-(s#(x#)),x#-1,yc%+200/20*-(s#(x#-1)):Rect x#,yc%+200/20*-(s#(x#)),3,3
		
		DrwSpd(x#,0,0,200)
		DrwAcc(x#,250,150,0)
		DrwForce(x#,100,10,200)
		f0#=f#(x#)

		If mode%=1 Then FlipCanvas can%:Delay (0.3/360*1000)
	Next
	If mode%=0 Then
		Color 0,0,0
		Text 50,10,"s Hub: "+smin#+" - "+smax#+"mm"
		Text 50,30,"v Hub: "+vmin#+" - "+vmax#+"m/s"
		Text 50,50,"a Hub: "+amin#+" - "+amax#+"m/s^2"
		Text 50,70,"F Hub: "+fmin#+" - "+fmax#+"N"
	End If
End Function

Function SpotValue()
	Cls
	If MouseDown(1)=True Then
		Color 240,240,240
		Rect mx%,0,MouseX(can%)-mx%,600
		SetStatusText win%,"Selektion: "+Float((MouseX(can%)-mx%)*(0.3/360))+"s"
		Color 40,40,40
		Line mx%,0,mx%,600
	End If
	If MouseDown(1)=False Then
		Color 240,240,240
		Rect mx%,0,mx2%-mx%,600
		Color 40,40,40
		Line mx%,0,mx%,600
		Line mx2%,0,mx2%,600
	End If
	Draw(0)
	Text 50,470,"w exc= "+MouseX(can%)+""
	Text 50,490,"t glb= "+Float(MouseX(can%)*(0.3/360))+"s"
	Text 50,510,"h Hub= "+s#(MouseX(can%))+"mm"
	Text 50,530,"v Hub= "+v#(MouseX(can%))+"m/s"
	Text 50,550,"a Hub= "+a#(MouseX(can%))+"m/s^2"
	Text 50,570,"F Hub= "+f#(MouseX(can%))+"N"
	Line MouseX(can%),0,MouseX(can%),600
	FlipCanvas can%
End Function

Function GetCurve(file$)
	If FileType(CurrentDir()+file$+".txt")=True Then
		filein%=ReadFile(CurrentDir()+file$+".txt")
			For i%=1 To 360
				grb#(i%)=Value(ReadLine(filein%))
			Next
		CloseFile filein%
	End If
End Function

Function WriteCurve(file$)
	fileout%=WriteFile(file$)
	If fileout%<>0 Then
		WriteLine fileout%,"excenter [%]"+Chr$(9)+"hub [mm]"+Chr$(9)+"s [mm]"+Chr$(9)+"v [mm/s]"+Chr$(9)+"a [mm/s^2]"+Chr$(9)+"F [N]"
		For i%=2 To 361
			WriteLine fileout%,exc#(i%)+Chr$(9)+lft#(i%)+Chr$(9)+s#(i%)+Chr$(9)+v#(i%)+Chr$(9)+a#(i%)+Chr$(9)+f#(i%)
		Next
		CloseFile fileout%
		If FileType(file$)=1 Then Notify("     Export erfolgreich.")
	Else
		Notify("     Export nicht erfolgreich.",1)
	End If
End Function

Function Value#(word$)
	If Left(word$,1)="-" Then
		pol%=-1
		word$=Replace(word$,"-","")
	Else
		pol%=1
	End If

	For i%=0 To Len(word$)
		Select Mid(word$,i%,1)
			Case "0"
				newword$=newword$+"0"		
			Case "1"
				newword$=newword$+"1"
			Case "2"
				newword$=newword$+"2"
			Case "3"
				newword$=newword$+"3"
			Case "4"
				newword$=newword$+"4"
			Case "5"
				newword$=newword$+"5"
			Case "6"
				newword$=newword$+"6"
			Case "7"
				newword$=newword$+"7"
			Case "8"
				newword$=newword$+"8"
			Case "9"
				newword$=newword$+"9"
			Case ",","."
				If part%=0 Then
					ppos%=i%-1
					part%=1
				End If
		End Select
	Next
	
	If ppos%=0 Then ppos%=Len(newword$)
	
	For i%=1 To Len(newword$)
		Select Mid(newword$,i%,1)
			Case "0"
				Value#=Value#+Int(0*10^(Len(newword$)-i%))		
			Case "1"
				Value#=Value#+Int(1*10^(Len(newword$)-i%))
			Case "2"
				Value#=Value#+Int(2*10^(Len(newword$)-i%))
			Case "3"
				Value#=Value#+Int(3*10^(Len(newword$)-i%))
			Case "4"
				Value#=Value#+Int(4*10^(Len(newword$)-i%))
			Case "5"
				Value#=Value#+Int(5*10^(Len(newword$)-i%))
			Case "6"
				Value#=Value#+Int(6*10^(Len(newword$)-i%))
			Case "7"
				Value#=Value#+Int(7*10^(Len(newword$)-i%))
			Case "8"
				Value#=Value#+Int(8*10^(Len(newword$)-i%))
			Case "9"
				Value#=Value#+Int(9*10^(Len(newword$)-i%))
		End Select
	Next
	
	result#=Float(Value#/(10^(Len(newword$)-ppos%))*pol%)
	
	Return result#
End Function


Function GetWinOSHandle(win)
	Return(QueryObject(win,1))	
End Function

Function SetWindowIcon(hWnd,ICOfile$)
	Local icon=ExtractIconA(hWnd,ICOfile$,0)
	SetClassLongA(hWnd,-14,icon)
End Function


;~IDEal Editor Parameters:
;~C#BlitzPlus